---
import SearchSvg from "@/shared/svgs/SearchSvg.astro";
import CloseSvg from "@/shared/svgs/CloseSvg.astro";

const queryParams = new URL(Astro.url).searchParams;

const inputValue = queryParams.get("search") ?? "";
---

<form id="form-search" class="relative w-min my-2">
  <input
    type="text"
    class={`
      bg-transparent outline outline-1 outline-neutral-100 focus:outline-2 
      focus:outline-violet-600 rounded py-[12px] pl-6 pr-14 placeholder:font-bold
    `}
    name="title"
    placeholder="Search"
    value={inputValue}
  />
  {
    inputValue && (
      <button
        type="button"
        class="rounded-md p-1 absolute top-[10px] right-[40px] hover:opacity-80"
        onclick="removeFilter()"
      >
        <CloseSvg size={20} color="rgb(220,38,38)" />
      </button>
    )
  }
  <button type="submit" class="rounded-md p-1 absolute top-[8px] right-2 hover:opacity-80">
    <SearchSvg size={24} color="rgb(139,92,246)" />
  </button>
</form>

<script is:inline>
  const form = document.querySelector("#form-search");
  const inputSearch = Array.from(form).find((vl) => vl.nodeName === "INPUT");

  function setSearch(value) {
    const lastQueryParams = new URLSearchParams(window.location.search);
    const queryParams = new URLSearchParams();
    if (!value) return (window.location.href = window.location.pathname);
    queryParams.set("search", value);
    const categoryId = lastQueryParams.get("category");
    if (categoryId) queryParams.set("category", categoryId);
    window.location.search = String(queryParams);
  }

  function removeFilter() {
    setSearch(null);
  }

  form.addEventListener("submit", (e) => {
    e.preventDefault();
    const value = inputSearch.value;
    if (!value) return;
    setSearch(value);
  });
</script>
